/*------------------------------------------------------------------------------
 bin/djv_view/image_magnify.h
 
 Image Magnify
 -------------

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_VIEW_IMAGE_MAGNIFY_H
#define DJV_VIEW_IMAGE_MAGNIFY_H

#include <djv_ui/dialog.h>

namespace djv_view {
namespace view { class Widget; }
namespace image_magnify {
using namespace djv_base;

//------------------------------------------------------------------------------
// Options

enum ZOOM
{
  ZOOM_100,
  ZOOM_200,
  ZOOM_400,
  ZOOM_800,
  ZOOM_1600
};

//------------------------------------------------------------------------------
// Dialog

class Dialog : public djv_ui::dialog::Base
{
public:
  
  Dialog();
  ~Dialog();
  void del();
  
  // Value.
  
  void set(const view::Widget *, const Vec2i &);
  void pick(const view::Widget *, const Vec2i &);
  void update(const view::Widget *);
  void del(const view::Widget *);
  
  // Widget.
  
  void show();
  
  // Layout.
  
  void update() { Base::update(); }

private:
  
  DJV_CALLBACK(Dialog, zoom_callback, int);
  DJV_CALLBACK(Dialog, close_callback, bool);
  
  void value_update();
  void widget_update();
  
  const view::Widget * _view;
  Vec2i _pick;
  ZOOM _zoom;
  
  struct _Dialog;
  std::auto_ptr<_Dialog> _p;
};

//------------------------------------------------------------------------------
// Conversion

Str & operator >> (Str &, ZOOM &) throw (Str);
Str & operator << (Str &, ZOOM);

//------------------------------------------------------------------------------
// Labels

const List<Str> & label_zoom();

extern const Str
  dialog_title;

//------------------------------------------------------------------------------
// Global

Dialog * dialog();

}
}

#endif

