/*------------------------------------------------------------------------------
 bin/djv_view/view_etc.cxx

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#include "view.h"

namespace djv_view {
namespace view {

DJV_STR_OPERATOR_SET(RESIZE, label_resize())
DJV_STR_OPERATOR_GET(RESIZE, label_resize())
DJV_STR_OPERATOR_SET(GRID, label_grid())
DJV_STR_OPERATOR_GET(GRID, label_grid())
DJV_STR_OPERATOR_SET(HUD_BACKGROUND, label_hud_background())
DJV_STR_OPERATOR_GET(HUD_BACKGROUND, label_hud_background())

const List<Str> & label_resize()
{
  static const List<Str> data = List<Str>() <<
    "None" <<
    "Fit" <<
    "Center";
  return data;
}

const List<Str> & label_grid()
{
  static const List<Str> data = List<Str>() <<
    "None" <<
    "1x1" <<
    "10x10" <<
    "100x100";
  return data;
}

const List<Str> & label_hud_info()
{
  static const List<Str> data = List<Str>() <<
    "File" <<
    "Image" <<
    "Image Tag" <<
    "Playback Time" <<
    "Playback Frame" <<
    "Playback Speed";
  return data;
}

const List<Str> & label_hud_mode()
{
  static const List<Str> data = List<Str>() <<
    "Off" <<
    "Top Left" <<
    "Top Right" <<
    "Bottom Left" <<
    "Bottom Right";
  return data;
}

const List<Str> & label_hud_background()
{
  static const List<Str> data = List<Str>() <<
    "None" <<
    "Solid" <<
    "Shadow";
  return data;
}

const Str
  menu_title = "&View",
  menu_left = "Left",
  menu_right = "Right",
  menu_up = "Up",
  menu_down = "Down",
  menu_center = "Center",
  menu_zoom_in = "Zoom In",
  menu_zoom_out = "Zoom Out",
  menu_zoom_reset = "Zoom Reset",
  menu_reset = "Reset",
  menu_fit = "Fit",
  menu_grid = "Grid",
  menu_hud = "HUD";

const Str
  toolbar_zoom = "%%%",
  toolbar_zoom_format = "000%";

const Str
  tooltip_zoom = "View zoom.",
  tooltip_zoom_in = "Zoom view in.\nKeyboard shortcut: %%",
  tooltip_zoom_out = "Zoom view out.\nKeyboard shortcut: %%",
  tooltip_zoom_reset = "Reset zoom.\nKeyboard shortcut: %%",
  tooltip_fit = "Fit view to image.\nKeyboard shortcut: %%";

const Str
  prefs_title = "View",
  prefs_background_group = "Background",
  prefs_background = "Color:",
  prefs_resize_group = "Resizing",
  prefs_resize = "Resize view to fit image:",
  prefs_grid_group = "Grid",
  prefs_grid = "Value:",
  prefs_grid_color = "Color:",
  prefs_hud_group = "HUD (Heads Up Display)",
  prefs_hud = "Enable.",
  prefs_hud_name = "Show image name.",
  prefs_hud_size = "Show image size.",
  prefs_hud_proxy = "Show image proxy.",
  prefs_hud_pixel = "Show image pixel.",
  prefs_hud_tag = "Show image tags.",
  prefs_hud_frame = "Show playback frame.",
  prefs_hud_speed = "Show playback speed.",
  prefs_hud_background = "Background:",
  prefs_hud_color = "Color:",
  prefs_hud_color_foreground = "(Foreground)",
  prefs_hud_color_background = "(Background)";

}
}

