/*------------------------------------------------------------------------------
 include/djv_base/box_.h
 
 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

namespace djv_base {
namespace box {

template<typename T, int D>
const int Box<T, D>::dimension = D;

template<typename T, int D>
inline Box<T, D>::Box() {}

template<typename T, int D>
inline Box<T, D>::Box(const Box<T, D> & in)
{
  set(in);
}

template<typename T, int D>
inline Box<T, D>::Box(const Vec<T, D> & position, const Vec<T, D> & size) :
  position(position),
  size(size)
{}

template<typename T, int D>
inline Box<T, D>::Box(const Vec<T, D> & size) : size(size) {}

template<typename T, int D>
inline void Box<T, D>::set(const Box<T, D> & in)
{
  position = in.position;
  size = in.size;
}

template<typename T, int D>
inline void Box<T, D>::position1(const Vec<T, D> & in)
{
  size = in - position;
}

template<typename T, int D>
inline Vec<T, D> Box<T, D>::position1() const
{
  return position + size;
}

template<typename T, int D>
inline void Box<T, D>::zero()
{
  position.zero();
  size.zero();
}

}
}

