/*------------------------------------------------------------------------------
 include/djv_base/error.h
 
 Errors
 ------
 
 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_ERROR_H
#define DJV_ERROR_H

#include <djv_base/list.h>
#include <djv_base/str.h>

namespace djv_base {
namespace error {

//------------------------------------------------------------------------------
// Error

class Error
{
public:

  Error();
  Error(const Str &);
  Error(const Str & prefix, const Str &);
  
  const Str & str() const;

  operator Str () const;

private:

  Str _str;
};

//------------------------------------------------------------------------------
// Functions

Str format(const Error &);

void print(const Error &);

//------------------------------------------------------------------------------
// Labels

extern const Str
  error_format;

}
}

#endif

