/*------------------------------------------------------------------------------
 include/djv_ui/base.h

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_UI_BASE_H
#define DJV_UI_BASE_H

#include <djv_base/vec.h>
#include <djv_image/profile.h>
#include <djv_ui/callback.h>
#include <FL/Enumerations.H>

namespace djv_ui {
using namespace djv_base;
namespace base {

//------------------------------------------------------------------------------
// Cursor

class Cursor
{
public:

  Cursor(const Fl_Cursor &);
  ~Cursor();
};

//------------------------------------------------------------------------------
// Tooltips

class Tooltip
{
public:

  Tooltip();

  void enable(bool);
  bool enable() const;

private:

  void enable_update();

  bool _enable;
};
  
//------------------------------------------------------------------------------
// Functions

void cursor(const Fl_Cursor &);

Vec2i str_size(const Str &);
int str_width(const Str &);

//------------------------------------------------------------------------------
// Preferences

class Prefs
{
public:

  Prefs();
  ~Prefs();
  
  // Tooltips.

  void tooltip(bool);
  bool tooltip() const;

private:

  bool _tooltip;
};

//------------------------------------------------------------------------------
// Labels

extern const Str
  tooltip_reset;

//------------------------------------------------------------------------------
// Global

class Global
{
public:

  Global();
  ~Global();
  
  Tooltip * tooltip() const;

private:

  std::auto_ptr<Tooltip> _tooltip;
};

Global * global();
Prefs * prefs();

}
}

#endif

