/*------------------------------------------------------------------------------
 include/djv_ui/image.h
 
 Images
 ------

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_UI_IMAGE_H
#define DJV_UI_IMAGE_H

#include <djv_image/gl_data.h>
#include <djv_image/time.h>
#include <djv_ui/widget.h>
#include <FL/Fl_Image.H>

namespace djv_ui {
namespace image {

//------------------------------------------------------------------------------
// Preferences

class Prefs
{
public:

  Prefs();
  ~Prefs();
  
  // Filter.
  
  void filter(djv_image::gl_data::Filter::FILTER);
  void filter_default(const djv_image::gl_data::Filter::Default &);
  void filter_custom(const djv_image::gl_data::Filter::Custom &);
  djv_image::gl_data::Filter::FILTER filter() const;
  const djv_image::gl_data::Filter::Default & filter_default() const;
  const djv_image::gl_data::Filter::Custom & filter_custom() const;

  // Speed.
  
  void speed(djv_image::time::FPS);
  djv_image::time::FPS speed() const;
  
  // Units.
  
  void units(djv_image::time::UNITS);
  djv_image::time::UNITS units() const;
};

//------------------------------------------------------------------------------
// Functions

Fl_Image * image_to_fltk(
  const djv_image::Data &,
  const Vec2i & resize = Vec2i(),
  const djv_image::Profile & = djv_image::Profile()
);

//------------------------------------------------------------------------------
// Labels

//extern const Str
//  prefs_units;

//------------------------------------------------------------------------------
// Global

Prefs * prefs();

}
}

#endif

