/*------------------------------------------------------------------------------
 include/djv_ui/prefs_.h

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

namespace djv_ui {
namespace prefs {

template<typename T>
inline void set(Prefs * prefs, const Str & name, const T & in)
{
  Str tmp;
  prefs->set(name, tmp << in);
}

template<typename T>
inline bool get(Prefs * prefs, const Str & name, T * out)
{
  Str tmp;
  if (! prefs->get(name, &tmp)) return false;
  try { tmp >> *out; }
  catch (Str) { return false; }
  return true;
}

}
}
