/*------------------------------------------------------------------------------
 lib/djv_image/profile.cxx

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#include <djv_image/profile.h>

namespace djv_image {
namespace profile {

bool operator == (const Exposure & a, const Exposure & b)
{
  return
    a.value == b.value &&
    a.defog == b.defog &&
    a.knee_low == b.knee_low &&
    a.knee_high == b.knee_high &&
    a.gamma == b.gamma;
}

bool operator != (const Exposure & a, Exposure & b)
{
  return ! (a == b);
}

bool operator == (const Profile & a, const Profile & b)
{
  return a.type == b.type && a.exposure == b.exposure;
}

bool operator != (const Profile & a, const Profile & b)
{
  return ! (a == b);
}

Str & operator >> (Str & in, Exposure & out) throw (Str)
{
  return in >> out.value >> out.defog >> out.knee_low >> out.knee_high >>
    out.gamma;
}

Str & operator << (Str & out, const Exposure & in)
{
  return out << in.value << in.defog << in.knee_low << in.knee_high << in.gamma;
}

DJV_STR_OPERATOR_SET(PROFILE, label_profile())
DJV_STR_OPERATOR_GET(PROFILE, label_profile())

const List<Str> & label_profile()
{
  static const List<Str> data = List<Str>() <<
    "Raw" <<
    "LUT" <<
    "Exposure";
  return data;
}

Dbg & operator << (Dbg & dbg, PROFILE & in)
{
  return dbg << str::label(in);
}

}
}
