/*------------------------------------------------------------------------------
 lib/djv_ui/image_io_etc.cxx

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#undef DJV_DBG
//#define DJV_DBG

#include <djv_ui/image_io.h>

namespace djv_ui {
namespace image_io {

const Str
  prefs_load_title = "Load",
  prefs_save_title = "Save";

Global::Global() :
  sig(this),
  _load(new Load_Factory),
  _save(new Save_Factory)
{
  DJV_DBG_OBJ("Global::Global");
}

Global::~Global()
{
  DJV_DBG_OBJ("Global::~Global");
}
  
Load_Factory * Global::load() const { return _load.get(); }
Save_Factory * Global::save() const { return _save.get(); }

}
}
