/*------------------------------------------------------------------------------
 lib/djv_ui/image_io_sgi.cxx
 
 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#undef DJV_DBG
//#define DJV_DBG

#include <djv_ui/choice.h>
#include <djv_ui/group.h>
#include <djv_ui/image_io_sgi.h>
#include <djv_ui/layout_row.h>
#include <djv_ui/label.h>
#include <djv_ui/style.h>

namespace djv_ui {
namespace image_io_sgi {
using namespace djv_image::io_sgi;

struct Save::_Save
{
  choice::Widget * compress;
};

Save::Save() :
  _plugin(0),
  _p(new _Save)
{
  // Widgets.
  
  group::Box * group =
    new group::Box(label_compress_group);
  _p->compress =
    new choice::Widget(djv_image::io_sgi::label_compress(), label_compress);
  
  // Layout.
  
  Layout_V * layout, * layout_group;
  
  layout = new Layout_V(this);

  layout->add(group);
  layout_group = new Layout_V(group);
  layout_group->spacing(style::global()->spacing_large());
  layout_group->add(_p->compress);
  
  layout->add_stretch();
  
  // Initialize.
  
  plugin_update();
  widget_update();
  
  // Callbacks.
  
  _p->compress->sig.set(this, compress_callback);
}

Save::~Save() {}

plugin::Plugin * Save::copy() const { return new Save; }

const Str & Save::name() const { return djv_image::io_sgi::name; }

void Save::set(djv_image::io::Plugin * in)
{
  _plugin = in;
  
  widget_update();
}

void Save::compress_callback(int in)
{
  if (! _plugin) return;
  
  _option.compress = COMPRESS(in);
  
  plugin_update();
  sig.emit(_plugin);
}

void Save::plugin_update()
{
  callbacks(false);
  
  if (_plugin)
  {
    Str tmp;
    tmp << _option.compress;
    _plugin->option(_plugin->option_list()[SAVE_COMPRESS], &tmp);
  }
  
  callbacks(true);
}

void Save::widget_update()
{
  callbacks(false);

try
{
  if (_plugin)
  {
    Str tmp;
    tmp = _plugin->option(_plugin->option_list()[SAVE_COMPRESS]);
    tmp >> _option.compress;
  }
}
catch (Str) {}

  _p->compress->set(_option.compress);
  
  callbacks(true);
}

const Str
  label_compress_group = "Compress",
  label_compress = "Value:";

}
}

