/*------------------------------------------------------------------------------
 plugin/djv_exr/ui.h

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_EXR_UI_H
#define DJV_EXR_UI_H

#include <djv_exr/io.h>
#include <djv_ui/image_io.h>

namespace djv_exr {
using namespace djv_ui;
namespace ui {

//------------------------------------------------------------------------------
// Load Widget

class Load : public image_io::Load
{
public:

  Load();
  
  plugin::Plugin * copy() const;
  const Str & name() const;

  void set(djv_image::io::Plugin *);
  
private:

  DJV_CALLBACK(Load, color_callback, int);
  DJV_CALLBACK(Load, exposure_callback, double);
  DJV_CALLBACK(Load, defog_callback, double);
  DJV_CALLBACK(Load, knee_low_callback, double);
  DJV_CALLBACK(Load, knee_high_callback, double);
  DJV_CALLBACK(Load, gamma_callback, double);
  DJV_CALLBACK(Load, callback, bool);
  
  void plugin_update();
  void widget_update();
  
  djv_image::io::Plugin * _plugin;
  io::Load_Option _option;
  
  struct _Load;
  std::auto_ptr<_Load> _p;
};

//------------------------------------------------------------------------------
// Save Widget

class Save : public image_io::Save
{
public:

  Save();

  plugin::Plugin * copy() const;
  const Str & name() const;

  void set(djv_image::io::Plugin *);
  
private:

  DJV_CALLBACK(Save, compress_callback, int);
  
  void plugin_update();
  void widget_update();

  djv_image::io::Plugin * _plugin;
  io::Save_Option _option;
  
  struct _Save;
  std::auto_ptr<_Save> _p;
};

//------------------------------------------------------------------------------
// Labels

extern const Str
  label_color_group,
  label_color,
  label_exposure_group,
  label_exposure,
  label_exposure_defog,
  label_exposure_knee,
  label_exposure_gamma,
  label_compress_group,
  label_compress;

}
}

#endif

