/*------------------------------------------------------------------------------
 plugin/djv_jpeg/ui.h

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_JPEG_UI_H
#define DJV_JPEG_UI_H

#include <djv_jpeg/io.h>
#include <djv_ui/image_io.h>

namespace djv_jpeg {
namespace ui {
using namespace djv_ui;

//------------------------------------------------------------------------------
// Save Widget

class Save : public image_io::Save
{
public:

  Save();

  Plugin * copy() const;
  const Str & name() const;

  void set(djv_image::io::Plugin *);
  
private:

  DJV_CALLBACK(Save, quality_callback, int);
  
  void plugin_update();
  void widget_update();

  djv_image::io::Plugin * _plugin;
  io::Save_Option _option;
  
  struct _Save;
  std::auto_ptr<_Save> _p;
};

//------------------------------------------------------------------------------
// Labels

extern const Str
  label_quality_group,
  label_quality;

}
}

#endif

