/*------------------------------------------------------------------------------
 plugin/djv_png/base.h

 Image I/O - PNG
 ---------------
 
 Portable Network Graphics image file format.

 Requires:
 
 * libpng - http://www.libpng.org

 Support:
 
 * Image data: L, RGB, RGBA, 8-bit, 16-bit.
 * File compression.

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_PNG_BASE_H
#define DJV_PNG_BASE_H

#include <djv_image/base.h>
#include <png.h>

namespace djv_png {
using namespace djv_base;
using namespace djv_image;

//------------------------------------------------------------------------------
// Information

static const Str name = "PNG";

static const List<Str> extension_list = List<Str>() << ".png";

//------------------------------------------------------------------------------
// Errors

struct Png_Error
{
  char msg [str::cstr_size];
};

extern "C" {

void djv_png_error(png_structp, png_const_charp);
void djv_png_warning(png_structp, png_const_charp);

}

}

#endif

