/*------------------------------------------------------------------------------
 plugin/djv_quicktime_unix/etc.cxx
 
 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

//#define DJV_DBG

#include "base.h"

namespace djv_quicktime {

namespace {

extern "C" {
void _log_callback(lqt_log_level_t, const char *, const char *, void *) {}
}

}

void quicktime_init()
{
  DJV_DBG_OBJ("quicktime_init");
  
  lqt_set_log_callback(_log_callback, 0);
  
  DJV_DBG_PRN("codec = " << label_codec());
}

List<Str> label_codec()
{
  List<Str> out;
  lqt_codec_info_t ** info = lqt_query_registry(0, 1, 1, 0);
  if (info)
  {
    for (int i = 0; info[i]; ++i)
      out += info[i]->name;
    lqt_destroy_codec_info(info);
  }
  return out;
}

const Str
  error_video = "No Video Tracks",
  error_codec = "Codec",
  error_colormodel = "Color Model";

}

