#include <djv_ui/layout_row.h>
#include <djv_ui/window.h>
#include <djv_ui/num_int.h>
#include <djv_ui/num_float.h>
#include <djv_ui/app.h>

class App : public djv_ui::app::App
{
public:

  App(int & argc, char ** argv);
  ~App();

private:

  DJV_CALLBACK(App, int_callback, int)
  {
    print(djv_base::str::Format("value = %%").arg(in));
  }
  DJV_CALLBACK(App, float_callback, double)
  {
    print(djv_base::str::Format("value = %%").arg(in));
  }
  
  DJV_CALLBACK(App, exit_callback, bool) { exit(); }

  djv_ui::window::Widget * _window;
};

App::App(int & argc, char ** argv) :
  djv_ui::app::App("sliders", argc, argv),
  _window(0)
{
  using namespace djv_base;
  using namespace djv_ui;

  valid(true);
  
  // Widgets.
  
  num::Int_Slider * int_widget = new num::Int_Slider;
  int_widget->range(0, 1000);
  int_widget->inc(10, 100);
  //int_widget->range(0, 10);
  
  num::Float_Slider * float_widget = new num::Float_Slider;
  float_widget->range(0.0, 100.0);
  float_widget->inc(1.0, 10.0);
  //float_widget->range(0.0, 3.0);
  
  _window = new window::Widget(name());
  
  // Layout.
  
  Layout_V * layout = new Layout_V(_window);
  layout->add(int_widget);
  layout->add(float_widget);
  
  // Initialize.
  
  _window->size(_window->size_hint());
  _window->show();

  // Callbacks.
  
  int_widget->sig.set(this, int_callback);
  float_widget->sig.set(this, float_callback);
  _window->close_sig.set(this, exit_callback);
}

App::~App()
{
  if (_window) _window->del();
}

int main(int argc, char ** argv) { return App(argc, argv).exec(); }

