#include "op_sharpen.h"
#include <djv_ui/group.h>
#include <djv_ui/layout_row.h>
#include <djv_ui/num_float.h>

namespace glsl {
namespace op_sharpen {

Op::Op() :
  _init(false)
{
  using namespace djv_ui;
  
  // Widgets.
  
  group::Box * value_group =
    new group::Box("Value");
  num::Float_Slider * value =
    new num::Float_Slider(0.0, 2.0);
  
  // Layout.
  
  Layout_V * layout = new Layout_V(this);
  layout->add(value_group);
  Layout_V * layout_v = new Layout_V(value_group);
  layout_v->add(value);
  layout->add_stretch();
  
  // Initialize.
  
  value->set(_value.value);
  
  // Callbacks.

  value->sig.set(this, value_callback);
}

void Op::value_callback(double in)
  { sig.emit((_value.value = in)); }

}
}
